/**********************************************************************************/
/*                                                                                */
/*        Copyright (C) 2005, WiNRADiO Communications, All Rights Reserved        */
/*                                                                                */
/**********************************************************************************/

#include "u_receiverdialog.h"

enum
{
    controlOKButton=100,
    controlList
};

BEGIN_EVENT_TABLE( TReceiverDialog, wxDialog )
        EVT_BUTTON(controlOKButton,TReceiverDialog::OnOKClick)
        EVT_LIST_ITEM_ACTIVATED(controlList,TReceiverDialog::OnItemDblClick)
END_EVENT_TABLE()

TReceiverDialog::TReceiverDialog(void):wxDialog(0,-1,"Select Receiver",wxDefaultPosition,wxSize(510,340))
{
 wxListItem Item;
 
    Centre();
    
    

    m_List=new wxListCtrl(this,controlList,wxPoint(10,24),wxSize(490,276),wxLC_REPORT|wxSUNKEN_BORDER|wxLC_SINGLE_SEL);
    m_OK=new wxButton(this,controlOKButton,"OK",wxPoint(345,308));
    m_Cancel=new wxButton(this,wxID_CANCEL,"Cancel",wxPoint(425,308));
    
    m_Label=new wxStaticText(this,-1,"Available G315 Receivers",wxPoint(10,5));
    
    m_OK->SetSize(wxSize(75,25));
    m_Cancel->SetSize(wxSize(75,25));
    
    
    Item.m_mask=wxLIST_MASK_TEXT|wxLIST_MASK_WIDTH;
    Item.m_text="Path";
    Item.m_width=100;
    m_List->InsertColumn(0,Item);

    Item.m_mask=wxLIST_MASK_TEXT|wxLIST_MASK_WIDTH;
    Item.m_text="Serial Number";
    Item.m_width=100;
    m_List->InsertColumn(1,Item);

    Item.m_mask=wxLIST_MASK_TEXT|wxLIST_MASK_WIDTH;
    Item.m_text="Intf";
    Item.m_width=40;
    Item.m_format=wxLIST_FORMAT_CENTER;
    m_List->InsertColumn(2,Item);

    Item.m_mask=wxLIST_MASK_TEXT|wxLIST_MASK_WIDTH|wxLIST_MASK_FORMAT;
    Item.m_text="Min. Frequency";
    Item.m_width=123;
    Item.m_format=wxLIST_FORMAT_RIGHT;
    m_List->InsertColumn(3,Item);

    Item.m_mask=wxLIST_MASK_TEXT|wxLIST_MASK_WIDTH|wxLIST_MASK_FORMAT;
    Item.m_text="Max. Frequency";
    Item.m_width=123;
    Item.m_format=wxLIST_FORMAT_RIGHT;
    m_List->InsertColumn(4,Item);
}

TReceiverDialog::~TReceiverDialog(void)
{
    delete m_List;
    delete m_OK;
    delete m_Cancel;
    delete m_Label;
}

void TReceiverDialog::AssignDeviceList(RADIO_INFO *List,int Count)
{
 wxListItem Item;
 int Index;
 wxString Buff;
 
    m_List->DeleteAllItems();
    
    List+=Count-1;
    
    for(int i=0;i<Count;i++,List--)
    {
        Item.m_text=List->Path;
        Item.m_mask=wxLIST_MASK_TEXT;
        Index=m_List->InsertItem(Item);

        m_List->SetItem(Index,1,List->SerNum);

        m_List->SetItem(Index,2,List->InterfaceType==INTERFACE_TYPE_USB?"USB":"PCI");

        Buff.Printf("%uHz",(unsigned int)List->MinFreq);
        m_List->SetItem(Index,3,Buff);

        Buff.Printf("%uHz",(unsigned int)List->MaxFreq);
        m_List->SetItem(Index,4,Buff);        
    }
}

bool GetReceiver(RADIO_INFO *List,int Count,wxString &Path)
{
 TReceiverDialog Dlg;
 
    if(Count==1)
    {
        Path=List->Path;
        return true;
    }
    else
    {
        Dlg.AssignDeviceList(List,Count);
    
        if(Dlg.ShowModal()==wxID_OK)
        {        
            Path=Dlg.GetPath();
            return true;
        }
    }
    
    return false;
}


void TReceiverDialog::OnOKClick(wxCommandEvent& Event)
{   
 long Item;
 
    Item=m_List->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    
    if(Item<0)
    {
        wxMessageBox("No receiver is selected","Information",wxICON_INFORMATION|wxOK,this);
    }
    else
    {
        m_Path=m_List->GetItemText(Item);
        EndModal(wxID_OK);
    }
}


void TReceiverDialog::OnItemDblClick(wxListEvent& Event)
{
 long Item;
 
    Item=m_List->GetNextItem(-1,wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
    
    if(Item>=0)
    {
        m_Path=m_List->GetItemText(Item);
        EndModal(wxID_OK);
    }   
}

