/**********************************************************************************/
/*                                                                                */
/*        Copyright (C) 2005, WiNRADiO Communications, All Rights Reserved        */
/*                                                                                */
/**********************************************************************************/

#include <wx/wx.h>
#include "wrg315demo.h"
#include "wrg315api.h"
#include "u_receiverdialog.h"
#include "u_mainwindow.h"


IMPLEMENT_APP(wrg315app);


bool wrg315app::OnInit()
{
 RADIO_INFO *List;
 uint32_t Count;
  
  
    if(!InitAPI())
    {
        wxMessageBox( wxT("Unable to load "WRG3APINAME" shared library."),wxT("Error"), wxOK | wxICON_STOP, NULL );
        return FALSE;
    }

    if(GetDeviceList(&List,&Count))
    {
        wxMessageBox(wxT("Unable to enumerate receivers."),wxT("Information"), wxOK | wxICON_INFORMATION, NULL );
    }

    if(!Count)
    {
        wxMessageBox( wxT("No available G315 receiver found."),wxT("Information"), wxOK | wxICON_INFORMATION, NULL );
        return FALSE;        
    }


    wxString Path;

    if(!GetReceiver(List,Count,Path))
    {
        return FALSE;
    }

    int hRadio;


    hRadio=OpenDevice(Path.c_str());

    if(hRadio<0) 
    {
        wxMessageBox("Unable to open radio device.","Error",wxICON_STOP|wxOK);
        return FALSE;
    }


    TMainWindow *MainWindow=new TMainWindow(hRadio,Path);

    if(!MainWindow->IsAudioOpened())
    {
        wxMessageBox("Unable to open audio device.","Question",wxICON_STOP|wxOK);
    }

    //StartStreaming(hRadio,TMainWindow::AudioCallback,NULL,TMainWindow::SpectrumCallback,MainWindow);     

    SetAudioCallback(hRadio,TMainWindow::AudioCallback,MainWindow);
    SetIFSpectrumCallback(hRadio,TMainWindow::SpectrumCallback,MainWindow);

    MainWindow->Show(TRUE);
    SetTopWindow(MainWindow);
    return TRUE;
} 


